local MODNAME         = "CrystalMote"
local FULLNAME        = "Broker_CrystalMote"
local CrystalMote     = LibStub( "AceAddon-3.0" ):NewAddon( MODNAME, "AceEvent-3.0" )
local L               = LibStub:GetLibrary( "AceLocale-3.0" ):GetLocale( MODNAME )
local AceConfig 	  = LibStub( "AceConfig-3.0" )
local AceConfigReg 	  = LibStub( "AceConfigRegistry-3.0" )
local AceConfigDialog = LibStub( "AceConfigDialog-3.0" )
local Crayon          = LibStub( "LibCrayon-3.0" )
_G[ MODNAME ] 		  = CrystalMote
local addon   		  = CrystalMote
local addonversion    = "1.0-beta"
local addonauthor     = "Gizmo"
local builddate       = "20090228"
local modularOptions  = {}
local tooltip
local LTT             = LibStub:GetLibrary( "LibQTip-1.0" )
addon.VERSION         = 1.0
local playerName      = UnitName("player")
local db 
local chardb

local defaults = {
	profile = {
		showShort  = false,
		showZero   = true,
		showBank   = true,
		showAlts   = true,
		showBC     = true,
		showLK     = true,
		display    = "all",
		scale      = 1,
	},
	realm = {
		chars = {
			['*'] = {
				data = {
					['*'] = { inv = 0, bank = 0, track = false, },
				}
			}
		}
	}
}

local displayOptions = nil
local function giveDisplay()
	if (not displayOptions) then
			displayOptions = {
				order = 5,
				type = "group",
				name = L["Display Options"],
				args = {
			nulloption = {
				order = 10,
				type  = "header",
				name  = L["Display Options"],
			},
			Zero = {
				type = "toggle",
				order = 15,
				name  = L["Include Zero Counts"],
				desc  = L["Include Zero Counts Desc"],
				get   = function() return db.profile.showZero end,
				set   = function()db.profile.showZero = not db.profile.showZero	end,
			},
			Bank = {
				type = "toggle",
				order = 20,
				name  = L["Include Bank Counts"],
				desc  = L["Include Bank Counts Desc"],
				get   = function() return db.profile.showBank end,
				set   = function() db.profile.showBank = not db.profile.showBank end,
			},
			Alts = {
				type = "toggle",
				order = 25,
				name  = L["Include Alt Counts"],
				desc  = L["Include Alt Counts Desc"],
				get   = function() return db.profile.showAlts end,
				set   = function() db.profile.showAlts = not db.profile.showAlts end,
			},
			nulloption0 = {
				order = 30,
				type  = "header",
				name  = L["Expansion Pack Select"],
			},
			burningcrusade = {
				type  = "toggle",
				order = 40,
				name  = ("|cff00ff00"..L["The Burning Crusade"].."|r"),
				desc  = L["The Burning Crusade Desc"],
				get   = function() return db.profile.showBC end,
				set   = function() db.profile.showBC = not db.profile.showBC end,
			},
			lichking = {
				type  = "toggle",
				order = 45,
				name  = ("|cff0066ff"..L["The Wrath of the Lich King"].."|r"),
				desc  = L["The Wrath of the Lich King Desc"],
				get   = function() return db.profile.showLK end,
				set   = function() db.profile.showLK = not db.profile.showLK end,
			},
			nulloption1 = {
				order = 50,
				type  = "header",
				name  = L["Tooltip Scale"],
			},
			Scale = {
				order   = 55,
				type	= "range",
				name	= L["Tooltip Scale"],
				desc	= L["Tooltip Scale Desc"],
				min		= .5,
				max		= 2.0,
				step	= .05,
				bigStep = .05,
				get		= function() return db.profile.scale end,
				set		= function( info, v ) 
									db.profile.scale = v
									tooltip:SetScale( v )
								    end,
			},
		},
	}
	end
	return displayOptions
end

local trackOptions = nil
local function giveTrack()
	if (not trackOptions) then
			trackOptions = {
				order = 1,
				type = "group",
				name = L["Tracking Options"],
				args = {
			nulloption = {
				order = 6,
				type  = "header",
				name  = L["Tracking Options"],
			},
			Tracker = {
				type  = "toggle",
				order = 10,
				name  = L["Show Short Text"],
				desc  = L["Show Short Text Desc"],
				get	  = function() return db.profile.showShort end,
				set   = function() db.profile.showShort = not db.profile.showShort end,
			},
			nulloption0 = {
				order = 15,
				type  = "header",
				name  = "",
			},
			AirM = {
				type  = "toggle",
				order = 20,
				name  = L["Tooltip_AirMotes"],
				get	  = function() return chardb.data.AirMotes.track end,
				set	  = function() chardb.data.AirMotes.track = not chardb.data.AirMotes.track 
						addon:Update()
						end,
			},
			AirP = {
				type  = "toggle",
				order = 25,
				name  = L["Tooltip_PrimalAir"],
				get	  = function() return chardb.data.PrimalAir.track end,
				set	  = function() chardb.data.PrimalAir.track = not chardb.data.PrimalAir.track
						addon:Update()
						end,
			},
			AirC = {
				type  = "toggle",
				order = 30,
				name  = L["Tooltip_AirCrystals"],
				get   = function() return chardb.data.AirCrystals.track end,
				set   = function() chardb.data.AirCrystals.track = not chardb.data.AirCrystals.track end,
			},
			AirE = {
				type  = "toggle",
				order = 35,
				name  = L["Tooltip_EternalAir"],
				get   = function() return chardb.data.EternalAir.track end,
				set   = function() chardb.data.EternalAir.track = not chardb.data.EternalAir.track end,
			},
			nulloption1 = {
				order = 40,
				type  = "header",
				name  = "",
			},
			FireM = {
				type  = "toggle",
				order = 45,
				name  = L["Tooltip_FireMotes"],
				get   = function() return chardb.data.FireMotes.track end,
				set   = function() chardb.data.FireMotes.track = not chardb.data.FireMotes.track end,
			},
			FireP = {
				type  = "toggle",
				order = 50,
				name  = L["Tooltip_PrimalFire"],
				get   = function() return chardb.data.PrimalFire.track end,
				set   = function() chardb.data.PrimalFire.track = not chardb.data.PrimalFire.track end,
			},
			FireC = {
				type  = "toggle",
				order = 55,
				name  = L["Tooltip_FireCrystals"],
				get   = function() return chardb.data.FireCrystals.track end,
				set   = function() chardb.data.FireCrystals.track = not chardb.data.FireCrystals.track end,
			},
			FireE= {
				type  = "toggle",
				order = 60,
				name  = L["Tooltip_EternalFire"],
				get   = function() return chardb.data.EternalFire.track end,
				set   = function() chardb.data.EternalFire.track = not chardb.data.EternalFire.track end,
			},
			nulloption2 = {
				order = 65,
				type  = "header",
				name  = "",
			},
			LifeM = {
				type  = "toggle",
				order = 70,
				name  = L["Tooltip_LifeMotes"],
				get   = function() return chardb.data.LifeMotes.track end,
				set   = function() chardb.data.LifeMotes.track = not chardb.data.LifeMotes.track end,
			},
			LifeP = {
				type  = "toggle",
				order = 75,
				name  = L["Tooltip_PrimalLife"],
				get   = function() return chardb.data.PrimalLife.track end,
				set   = function() chardb.data.PrimalLife.track = not chardb.data.PrimalLife.track end,
			},
			LifeC = {
				type  = "toggle",
				order = 80,
				name  = L["Tooltip_LifeCrystals"],
				get   = function() return chardb.data.LifeCrystals.track end,
				set   = function() chardb.data.LifeCrystals.track = not chardb.data.LifeCrystals.track end,
			},
			LifeE = {
				type  = "toggle",
				order = 85,
				name  = L["Tooltip_EternalLife"],
				get   = function() return chardb.data.EternalLife.track end,
				set   = function() chardb.data.EternalLife.track = not chardb.data.EternalLife.track end,
			},
			nulloption3 = {
				order = 90,
				type  = "header",
				name  = "",
			},
			ManaM = {
				type  = "toggle",
				order = 95,
				name  = L["Tooltip_ManaMotes"],
				get   = function() return chardb.data.ManaMotes.track end,
				set   = function() chardb.data.ManaMotes.track = not chardb.data.ManaMotes.track end,
			},
			ManaP = {
				type  = "toggle",
				order = 100,
				name  = L["Tooltip_PrimalMana"],
				get   = function() return chardb.data.PrimalMana.track end,
				set   = function() chardb.data.PrimalMana.track = not chardb.data.PrimalMana.track end,
			},
			nulloption4 = {
				order = 105,
				type  = "header",
				name  = "",
			},
			EarthM = {
				type  = "toggle",
				order = 110,
				name  = L["Tooltip_EarthMotes"],
				get   = function() return chardb.data.EarthMotes.track end,
				set   = function() chardb.data.EarthMotes.track = not chardb.data.EarthMotes.track end,
			},
			EarthP = {
				type  = "toggle",
				order = 115,
				name  = L["Tooltip_PrimalEarth"],
				get   = function() return chardb.data.PrimalEarth.track end,
				set   = function() chardb.data.PrimalEarth.track = not chardb.data.PrimalEarth.track end,
			},
			EarthC = {
				type  = "toggle",
				order = 120,
				name  = L["Tooltip_EarthCrystals"],
				get   = function() return chardb.data.EarthCrystals.track end,
				set   = function() chardb.data.EarthCrystals.track = not chardb.data.EarthCrystals.track end,
			},
			EarthE = {
				type  = "toggle",
				order = 125,
				name  = L["Tooltip_EternalEarth"],
				get   = function() return chardb.data.EternalEarth.track end,
				set   = function() chardb.data.EternalEarth.track = not chardb.data.EternalEarth.track end,
			},
			nulloption5 = {
				order = 130,
				type  = "header",
				name  = "",
			},
			WaterM = {
				type  = "toggle",
				order = 135,
				name  = L["Tooltip_WaterMotes"],
				get   = function() return chardb.data.WaterMotes.track end,
				set   = function() chardb.data.WaterMotes.track = not chardb.data.WaterMotes.track end,
			},
			WaterP = {
				type  = "toggle",
				order = 140,
				name  = L["Tooltip_PrimalWater"],
				get   = function() return chardb.data.PrimalWater.track end,
				set   = function() chardb.data.PrimalWater.track = not chardb.data.PrimalWater.track end,
			},
			WaterC = {
				type  = "toggle",
				order = 145,
				name  = L["Tooltip_WaterCrystals"],
				get   = function() return chardb.data.WaterCrystals.track end,
				set   = function() chardb.data.WaterCrystals.track = not chardb.data.WaterCrystals.track end,
			},
			WaterE = {
				type  = "toggle",
				order = 150,
				name  = L["Tooltip_EternalWater"],
				get   = function() return chardb.data.EternalWater.track end,
				set   = function() chardb.data.EternalWater.track = not chardb.data.EternalWater.track end,
			},
			nulloption6 = {
				order = 155,
				type  = "header",
				name  = "",
			},
			ShadowM = {
				type  = "toggle",
				order = 160,
				name  = L["Tooltip_ShadowMotes"],
				get   = function() return chardb.data.ShadowMotes.track end,
				set   = function() chardb.data.ShadowMotes.track = not chardb.data.ShadowMotes.track end,
			},
			ShadowP = {
				type  = "toggle",
				order = 165,
				name  = L["Tooltip_PrimalShadow"],
				get   = function() return chardb.data.PrimalShadow.track end,
				set   = function() chardb.data.PrimalShadow.track = not chardb.data.PrimalShadow.track end,
			},
			ShadowC = {
				type  = "toggle",
				order = 170,
				name  = L["Tooltip_ShadowCrystals"],
				get   = function() return chardb.data.ShadowCrystals.track end,
				set   = function() chardb.data.ShadowCrystals.track = not chardb.data.ShadowCrystals.track end,
			},
			ShadowE = {
				type  = "toggle",
				order = 175,
				name  = L["Tooltip_EternalShadow"],
				get   = function() return chardb.data.EternalShadow.track end,
				set   = function() chardb.data.EternalShadow.track = not chardb.data.EternalShadow.track end,
			},
			nulloption7 = {
				order = 180,
				type  = "header",
				name  = "",
			},
			MightP = {
				type  = "toggle",
				order = 185,
				name  = L["Tooltip_PrimalMight"],
				get   = function() return chardb.data.PrimalMight.track end,
				set   = function() chardb.data.PrimalMight.track = not chardb.data.PrimalMight.track end,
			},
			MightE = {
				type  = "toggle",
				order = 190,
				name  = L["Tooltip_EternalMight"],
				get   = function() return chardb.data.EternalMight.track end,
				set   = function() chardb.data.EternalMight.track = not chardb.data.EternalMight.track end,
			},
		},
	}
	end
	return trackOptions
end

local options = nil
local function fullOptions()
	if (not options) then
		options = {
			type = "group",
			name = MODNAME,
			args = {
				general = {
					order	= 5,
					type	= "group",
					name	= L["General Information"],
					desc	= L["General Info Desc"],
					args	= {
						header1 = {
							order	= 10,
							type	= "header",
							name	= L["General Information"],
						},
						author = {
							order	= 20,
							type	= "description",
							name	= L["Author : "] .. addonauthor .. "\n",
						},
						version = {
							order	= 25,
							type	= "description",
							name	= L["Version : "] .. addonversion .. "\n",
						},
						builddate = {
							order	= 30,
							type	= "description",
							name	= L["Build Date : "] .. builddate .. "\n",
						},
					},
				},
			},
		}
	end
	for k,v in pairs(modularOptions) do
		options.args[k] = (type(v) == "function") and v() or v
	end
	return options
end

local function HideTooltip()
	tooltip:SetScript( "OnLeave", nil )
	tooltip:Hide()
	tooltip:Clear()
end

local function drawTooltip()
	tooltip:Hide()
	tooltip:Clear()
	tooltip:SetScale( db.profile.scale )
	if db.profile.showAlts then 
		tooltip:AddLine( nil, nil, addon:TooltipNames() ) 
	end
	if db.profile.showBC and db.profile.showLK then 
		db.profile.display = "all"
	elseif db.profile.showLK then
		db.profile.display = "lichking"
	elseif db.profile.showBC then
		db.profile.display = "burningcrusade"
	else
		db.profile.display = "none"
	end
	for i, element in pairs(addon.display[db.profile.display]) do
		if db.profile.showZero or addon:CharHasElement(element) then
    		tooltip:AddLine( L["Tooltip_" .. (element)], nil, addon:TooltipElements(element) )
		end
	end
end

local LDB = LibStub( "LibDataBroker-1.1" )
local bcm = LDB:NewDataObject( MODNAME, {
	type = "data source",
	text = "TEST",
	label = FULLNAME,
	icon = "Interface\\Icons\\INV_Elemental_Eternal_Life",
	OnClick = function( clickedframe, button )
				if button == "RightButton" then
					addon:ShowDisp()
				elseif
				    button == "LeftButton" then
					addon:ShowTrack()
				else
					drawTooltip()
					tooltip:SmartAnchorTo( clickedframe )
					tooltip:Show()
				end
	end,
	OnEnter = function ( self )
		drawTooltip()
		tooltip:EnableMouse()
		tooltip:SmartAnchorTo( self )
		tooltip:Show()
	end,
	OnLeave = function ( self )
		if MouseIsOver( tooltip ) then
			tooltip:SetScript( 'OnLeave', HideTooltip )
		else
			HideTooltip()
		end
	end,
} )

local function onTextUpdate()
	local tracktext = ""
	local textcount = 0
	for i, element in pairs(addon.display.all) do
		if chardb.data[element].track then
			if chardb.data[element].track then
				textcount = textcount + 1
			else
			    textcount = textcount - 1
			end
			local name
			if db.profile.showShort then
		        name = L["Short_" .. (element)]
		    else
		        name = L["Tooltip_" .. (element)]
		    end
			if textcount == 1 then
				tracktext = tracktext .. " " .. (name) .. " " .. Crayon:Colorize(Crayon:GetThresholdHexColor(chardb.data[element].inv, 0, 5, 10), chardb.data[element].inv)
			else
				tracktext = tracktext .. " | " .. (name) .. " " .. Crayon:Colorize(Crayon:GetThresholdHexColor(chardb.data[element].inv, 0, 5, 10), chardb.data[element].inv)
			end
		end
	end	    
	bcm.text = tracktext
end

function addon:OnInitialize()
	self.charName = playerName
	self.db = LibStub("AceDB-3.0"):New(MODNAME .. "_DB", defaults)
	self.db.RegisterCallback(self, "OnProfileChanged", "OnProfileChanged")
	self.db.RegisterCallback(self, "OnProfileCopied", "OnProfileChanged")
	self.db.RegisterCallback(self, "OnProfileReset", "OnProfileChanged")
	db = self.db
	chardb = self.db.realm.chars[self.charName]
	if not chardb.class then
		local class  = strupper(select(2,UnitClass("player")))
		chardb.class = string.gsub(class, " ", "")
	end
end

function addon:OnEnable()
	self:RegisterEvent("BAG_UPDATE", "CountInv")
	local colnum = self:CharCount(db.realm.chars)
	tooltip = LTT:Acquire( MODNAME.."TT", colnum, "LEFT", "CENTER", "CENTER", "CENTER", "CENTER", "CENTER", "CENTER", "CENTER", "CENTER", "CENTER", "CENTER")
	addon:Update()
	addon:SetupOptions()
end

function addon:ShowDisp()
	InterfaceOptionsFrame_OpenToCategory( self.optionsFrame["Display"] )
end

function addon:ShowTrack()
	InterfaceOptionsFrame_OpenToCategory( self.optionsFrame["Tracking"] )
end

function addon:SetupOptions()
	AceConfigReg:RegisterOptionsTable(MODNAME, fullOptions)
	self.optionsFrame = AceConfigDialog:AddToBlizOptions(MODNAME, nil, nil, "general")
	self:RegisterModuleOptions("Display", giveDisplay(), L["Display Options"])
	self:RegisterModuleOptions("Tracking", giveTrack(), L["Tracking Options"])
	self:RegisterModuleOptions("Profiles", LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db), L["Profiles"])
end

function addon:RegisterModuleOptions(name, optionsTable, displayName)
	modularOptions[name] = optionsTable
	self.optionsFrame[name] = AceConfigDialog:AddToBlizOptions(MODNAME, displayName, MODNAME, name)
end

function addon:OnProfileChanged(event, database, newProfileKey)
	db = database.profile
end

function addon:Update()
	onTextUpdate()
end

function addon:CharCount(tab)
	if not db.profile.showAlts then 
		return 2
	end
	local n = 2
	for _ in pairs(tab) do
		n = n + 1
		if n >= 10 then
			n = 11
		end
	end
   return n
end

function addon:TooltipNames()
	local names = {self.charName}
 	if db.profile.showAlts then
		for char, _ in pairs(db.realm.chars) do
	    	if char ~= self.charName then
	    		table.insert(names, char)  	
	    	end
		end
	end
	return unpack(names)

end

function addon:CharHasElement(element)
	if chardb.data[element].inv > 0 or (db.profile.showBank and chardb.data[element].bank > 0) then
		return true
	end
	
    if db.profile.showAlts then
		for char, _ in pairs(db.realm.chars) do
			if db.realm.chars[char].data[element].inv > 0 or (db.profile.showBank and db.realm.chars[char].data[element].bank > 0) then
				return true
			end
		end
	end
	return false
end

function addon:TooltipElements(element)
	local elements = { self:CountString(element) }
	if db.profile.showAlts then
		for char, _ in pairs(db.realm.chars) do
	    	if char ~= self.charName then
	    		table.insert(elements, self:CountString(element, char))	    	
	    	end
		end
	end 
	return unpack(elements)
end

function addon:CountString(element, char)
	return self:InvCountString(element, char) .. self:BankCountString(element, char)
end

function addon:InvCountString(element, char)
	local tempChar = db.realm.chars[self.charName]	
	if char then
		tempChar = db.realm.chars[char]
	end	
	return Crayon:Colorize(Crayon:GetThresholdHexColor(tempChar.data[element].inv, 0, 5, 10), tempChar.data[element].inv)
end 

function addon:BankCountString(element, char)
	local tempChar = db.realm.chars[self.charName]
	if char then
		tempChar = db.realm.chars[char]
	end	
	if db.profile.showBank then
		return " (" .. Crayon:Colorize(Crayon:GetThresholdHexColor(tempChar.data[element].bank, 0, 5, 10), tempChar.data[element].bank) .. ")"
	else
		return ""
	end
end 

function addon:CountInv()	
	local data = chardb.data
	data.AirMotes.inv        = GetItemCount( 22572 )
	data.AirMotes.bank       = GetItemCount( 22572, true ) 
	data.AirMotes.bank       = data.AirMotes.bank - data.AirMotes.inv
	data.FireMotes.inv       = GetItemCount( 22574 )
	data.FireMotes.bank      = GetItemCount( 22574, true ) 
	data.FireMotes.bank      = data.FireMotes.bank - data.FireMotes.inv
	data.LifeMotes.inv       = GetItemCount( 22575 )
	data.LifeMotes.bank      = GetItemCount( 22575, true ) 
	data.LifeMotes.bank      = data.LifeMotes.bank - data.LifeMotes.inv
	data.ManaMotes.inv       = GetItemCount( 22576 )
	data.ManaMotes.bank      = GetItemCount( 22576, true ) 
	data.ManaMotes.bank      = data.ManaMotes.bank - data.ManaMotes.inv
	data.EarthMotes.inv      = GetItemCount( 22573 )
	data.EarthMotes.bank     = GetItemCount( 22573, true ) 
	data.EarthMotes.bank     = data.EarthMotes.bank - data.EarthMotes.inv
	data.WaterMotes.inv      = GetItemCount( 22578 )
	data.WaterMotes.bank     = GetItemCount( 22578, true ) 
	data.WaterMotes.bank     = data.WaterMotes.bank - data.WaterMotes.inv
	data.ShadowMotes.inv     = GetItemCount( 22577 )
	data.ShadowMotes.bank    = GetItemCount( 22577, true ) 
	data.ShadowMotes.bank    = data.ShadowMotes.bank - data.ShadowMotes.inv
    data.PrimalAir.inv       = GetItemCount( 22451 )
	data.PrimalAir.bank      = GetItemCount( 22451, true ) 
	data.PrimalAir.bank      = data.PrimalAir.bank - data.PrimalAir.inv
	data.PrimalFire.inv      = GetItemCount( 21884 )
	data.PrimalFire.bank     = GetItemCount( 21884, true ) 
	data.PrimalFire.bank     = data.PrimalFire.bank - data.PrimalFire.inv
	data.PrimalLife.inv      = GetItemCount( 21886 )
	data.PrimalLife.bank     = GetItemCount( 21886, true ) 
	data.PrimalLife.bank     = data.PrimalLife.bank - data.PrimalLife.inv
	data.PrimalMana.inv      = GetItemCount( 22457 )
	data.PrimalMana.bank     = GetItemCount( 22457, true ) 
	data.PrimalMana.bank     = data.PrimalMana.bank - data.PrimalMana.inv
	data.PrimalEarth.inv     = GetItemCount( 22452 )
	data.PrimalEarth.bank    = GetItemCount( 22452, true ) 
	data.PrimalEarth.bank    = data.PrimalEarth.bank - data.PrimalEarth.inv
	data.PrimalWater.inv     = GetItemCount( 21885 )
	data.PrimalWater.bank    = GetItemCount( 21885, true ) 
	data.PrimalWater.bank    = data.PrimalWater.bank - data.PrimalWater.inv
	data.PrimalShadow.inv    = GetItemCount( 22456 )
	data.PrimalShadow.bank   = GetItemCount( 22456, true ) 
	data.PrimalShadow.bank   = data.PrimalShadow.bank - data.PrimalShadow.inv
	data.PrimalMight.inv     = GetItemCount( 23571 )
	data.PrimalMight.bank    = GetItemCount( 23571, true ) 
	data.PrimalMight.bank    = data.PrimalMight.bank - data.PrimalMight.inv
	data.AirCrystals.inv     = GetItemCount( 37700 )
	data.AirCrystals.bank    = GetItemCount( 37700, true ) 
	data.AirCrystals.bank    = data.AirCrystals.bank - data.AirCrystals.inv
	data.FireCrystals.inv    = GetItemCount( 37702 )
	data.FireCrystals.bank   = GetItemCount( 37702, true ) 
	data.FireCrystals.bank   = data.FireCrystals.bank - data.FireCrystals.inv
	data.LifeCrystals.inv    = GetItemCount( 37704 )
	data.LifeCrystals.bank   = GetItemCount( 37704, true ) 
	data.LifeCrystals.bank   = data.LifeCrystals.bank - data.LifeCrystals.inv
	data.EarthCrystals.inv   = GetItemCount( 37701 )
	data.EarthCrystals.bank  = GetItemCount( 37701, true ) 
	data.EarthCrystals.bank  = data.EarthCrystals.bank - data.EarthCrystals.inv
	data.WaterCrystals.inv   = GetItemCount( 37705 )
	data.WaterCrystals.bank  = GetItemCount( 37705, true ) 
	data.WaterCrystals.bank  = data.WaterCrystals.bank - data.WaterCrystals.inv
	data.ShadowCrystals.inv  = GetItemCount( 37703 )
	data.ShadowCrystals.bank = GetItemCount( 37703, true ) 
	data.ShadowCrystals.bank = data.ShadowCrystals.bank - data.ShadowCrystals.inv
    data.EternalAir.inv      = GetItemCount( 35623 )
	data.EternalAir.bank     = GetItemCount( 35623, true ) 
	data.EternalAir.bank     = data.EternalAir.bank - data.EternalAir.inv
	data.EternalFire.inv     = GetItemCount( 36860 )
	data.EternalFire.bank    = GetItemCount( 36860, true ) 
	data.EternalFire.bank    = data.EternalFire.bank - data.EternalFire.inv
	data.EternalLife.inv     = GetItemCount( 35625 )
	data.EternalLife.bank    = GetItemCount( 35625, true ) 
	data.EternalLife.bank    = data.EternalLife.bank - data.EternalLife.inv
	data.EternalEarth.inv    = GetItemCount( 35624 )
	data.EternalEarth.bank   = GetItemCount( 35624, true ) 
	data.EternalEarth.bank   = data.EternalEarth.bank - data.EternalEarth.inv
	data.EternalWater.inv    = GetItemCount( 35622 )
	data.EternalWater.bank   = GetItemCount( 35622, true ) 
	data.EternalWater.bank   = data.EternalWater.bank - data.EternalWater.inv
	data.EternalShadow.inv   = GetItemCount( 35627 )
	data.EternalShadow.bank  = GetItemCount( 35627, true ) 
	data.EternalShadow.bank  = data.EternalShadow.bank - data.EternalShadow.inv
	data.EternalMight.inv    = GetItemCount( 40248 )
	data.EternalMight.bank   = GetItemCount( 40248, true ) 
	data.EternalMight.bank   = data.EternalMight.bank - data.EternalMight.inv
end

addon.display = {
	burningcrusade = {
	    L["AirMotes"],
	    L["PrimalAir"],
		L["FireMotes"],
		L["PrimalFire"],
		L["LifeMotes"],
		L["PrimalLife"],
		L["ManaMotes"],
		L["PrimalMana"],
		L["EarthMotes"],
		L["PrimalEarth"],
	    L["WaterMotes"],
	    L["PrimalWater"],
		L["ShadowMotes"],
		L["PrimalShadow"],
		L["PrimalMight"],
	},
	lichking = {
	    L["AirCrystals"],
	    L["EternalAir"],
		L["FireCrystals"],
		L["EternalFire"],
		L["LifeCrystals"],
		L["EternalLife"],
		L["EarthCrystals"],
		L["EternalEarth"],
	    L["WaterCrystals"],
	    L["EternalWater"],
		L["ShadowCrystals"],
		L["EternalShadow"],
		L["EternalMight"],
	},
	all = {
	    L["AirMotes"],
	    L["PrimalAir"],
		L["FireMotes"],
		L["PrimalFire"],
		L["LifeMotes"],
		L["PrimalLife"],
		L["ManaMotes"],
		L["PrimalMana"],
		L["EarthMotes"],
		L["PrimalEarth"],
	    L["WaterMotes"],
	    L["PrimalWater"],
		L["ShadowMotes"],
		L["PrimalShadow"],
		L["PrimalMight"],
	    L["AirCrystals"],
	    L["EternalAir"],
		L["FireCrystals"],
		L["EternalFire"],
		L["LifeCrystals"],
		L["EternalLife"],
		L["EarthCrystals"],
		L["EternalEarth"],
	    L["WaterCrystals"],
	    L["EternalWater"],
		L["ShadowCrystals"],
		L["EternalShadow"],
		L["EternalMight"],
	},
	none = { },
}